//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class CMAPTorsionForce : Force {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal CMAPTorsionForce(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.CMAPTorsionForce_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(CMAPTorsionForce obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~CMAPTorsionForce() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_CMAPTorsionForce(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public CMAPTorsionForce() : this(OpenMMSwigPINVOKE.new_CMAPTorsionForce(), true) {
  }

  public int getNumMaps() {
    int ret = OpenMMSwigPINVOKE.CMAPTorsionForce_getNumMaps(swigCPtr);
    return ret;
  }

  public int getNumTorsions() {
    int ret = OpenMMSwigPINVOKE.CMAPTorsionForce_getNumTorsions(swigCPtr);
    return ret;
  }

  public int addMap(int size, SWIGTYPE_p_std__vectorT_double_t energy) {
    int ret = OpenMMSwigPINVOKE.CMAPTorsionForce_addMap(swigCPtr, size, SWIGTYPE_p_std__vectorT_double_t.getCPtr(energy));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void getMapParameters(int index, SWIGTYPE_p_int size, SWIGTYPE_p_std__vectorT_double_t energy) {
    OpenMMSwigPINVOKE.CMAPTorsionForce_getMapParameters(swigCPtr, index, SWIGTYPE_p_int.getCPtr(size), SWIGTYPE_p_std__vectorT_double_t.getCPtr(energy));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setMapParameters(int index, int size, SWIGTYPE_p_std__vectorT_double_t energy) {
    OpenMMSwigPINVOKE.CMAPTorsionForce_setMapParameters(swigCPtr, index, size, SWIGTYPE_p_std__vectorT_double_t.getCPtr(energy));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addTorsion(int map, int a1, int a2, int a3, int a4, int b1, int b2, int b3, int b4) {
    int ret = OpenMMSwigPINVOKE.CMAPTorsionForce_addTorsion(swigCPtr, map, a1, a2, a3, a4, b1, b2, b3, b4);
    return ret;
  }

  public void getTorsionParameters(int index, SWIGTYPE_p_int map, SWIGTYPE_p_int a1, SWIGTYPE_p_int a2, SWIGTYPE_p_int a3, SWIGTYPE_p_int a4, SWIGTYPE_p_int b1, SWIGTYPE_p_int b2, SWIGTYPE_p_int b3, SWIGTYPE_p_int b4) {
    OpenMMSwigPINVOKE.CMAPTorsionForce_getTorsionParameters(swigCPtr, index, SWIGTYPE_p_int.getCPtr(map), SWIGTYPE_p_int.getCPtr(a1), SWIGTYPE_p_int.getCPtr(a2), SWIGTYPE_p_int.getCPtr(a3), SWIGTYPE_p_int.getCPtr(a4), SWIGTYPE_p_int.getCPtr(b1), SWIGTYPE_p_int.getCPtr(b2), SWIGTYPE_p_int.getCPtr(b3), SWIGTYPE_p_int.getCPtr(b4));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setTorsionParameters(int index, int map, int a1, int a2, int a3, int a4, int b1, int b2, int b3, int b4) {
    OpenMMSwigPINVOKE.CMAPTorsionForce_setTorsionParameters(swigCPtr, index, map, a1, a2, a3, a4, b1, b2, b3, b4);
  }

  public void updateParametersInContext(Context context) {
    OpenMMSwigPINVOKE.CMAPTorsionForce_updateParametersInContext(swigCPtr, Context.getCPtr(context));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setUsesPeriodicBoundaryConditions(bool periodic) {
    OpenMMSwigPINVOKE.CMAPTorsionForce_setUsesPeriodicBoundaryConditions(swigCPtr, periodic);
  }

  public override bool usesPeriodicBoundaryConditions() {
    bool ret = OpenMMSwigPINVOKE.CMAPTorsionForce_usesPeriodicBoundaryConditions(swigCPtr);
    return ret;
  }

}

}
